PipeWire: Logging

PipeWire 0.3.67

Loading...
Searching...
No Matches
Files | Macros | Functions | Variables
Logging
Utilities

Logging functions of PipeWire. More...

## Files
file | src/pipewire/log.h
| `pipewire/log.h`

## Macros
#define | PW_LOG_TOPIC_STATIC(var, topic)
| Declare a static log topic named var.
#define | PW_LOG_TOPIC_EXTERN(var) extern struct spa_log_topic *var
| Declare a static log topic named var.
#define | PW_LOG_TOPIC(var, topic)
| Declare a static log topic named var.
#define | PW_LOG_TOPIC_INIT(var) spa_log_topic_init(pw_log_get(), var);
#define | pw_log_level_enabled(lev) (pw_log_level >= (lev))
| Check if a loglevel is enabled.
#define | pw_log_topic_enabled(lev, t) ((t) && (t)->has_custom_level ? (t)->level >= (lev) : pw_log_level_enabled((lev)))
#define | pw_logtv(lev, topic, fmt, ap)
#define | pw_logt(lev, topic, ...)
#define | pw_log(lev, ...) pw_logt(lev,PW_LOG_TOPIC_DEFAULT,__VA_ARGS__)
#define | pw_log_error(...) pw_log(SPA_LOG_LEVEL_ERROR,__VA_ARGS__)
#define | pw_log_warn(...) pw_log(SPA_LOG_LEVEL_WARN,__VA_ARGS__)
#define | pw_log_info(...) pw_log(SPA_LOG_LEVEL_INFO,__VA_ARGS__)
#define | pw_log_debug(...) pw_log(SPA_LOG_LEVEL_DEBUG,__VA_ARGS__)
#define | pw_log_trace(...) pw_log(SPA_LOG_LEVEL_TRACE,__VA_ARGS__)
#define | pw_logt_error(t, ...) pw_logt(SPA_LOG_LEVEL_ERROR,t,__VA_ARGS__)
#define | pw_logt_warn(t, ...) pw_logt(SPA_LOG_LEVEL_WARN,t,__VA_ARGS__)
#define | pw_logt_info(t, ...) pw_logt(SPA_LOG_LEVEL_INFO,t,__VA_ARGS__)
#define | pw_logt_debug(t, ...) pw_logt(SPA_LOG_LEVEL_DEBUG,t,__VA_ARGS__)
#define | pw_logt_trace(t, ...) pw_logt(SPA_LOG_LEVEL_TRACE,t,__VA_ARGS__)
#define | pw_log_trace_fp(...) pw_log(SPA_LOG_LEVEL_TRACE,__VA_ARGS__)

## Functions
void | pw_log_set (struct spa_log *log)
| Configure a logging module.
struct spa_log * | pw_log_get (void)
| Get the log interface.
void | pw_log_set_level (enum spa_log_level level)
| Configure the logging level.
void | pw_log_logt (enum spa_log_level level, const struct spa_log_topic *topic, const char *file, int line, const char *func, const char *fmt,...) 1(6
| Log a message for a topic.
void void | pw_log_logtv (enum spa_log_level level, const struct spa_log_topic *topic, const char *file, int line, const char *func, const char *fmt, va_list args) 1(6
| Log a message for a topic.
void void void | pw_log_log (enum spa_log_level level, const char *file, int line, const char *func, const char *fmt,...) 1(5
| Log a message for the default topic.
void void void void | pw_log_logv (enum spa_log_level level, const char *file, int line, const char *func, const char *fmt, va_list args) 1(5
| Log a message for the default topic.
void void void void void | _pw_log_topic_new (struct spa_log_topic *topic)
| Initialize the log topic.

## Variables
enum spa_log_level | pw_log_level
| The global log level.
struct spa_log_topic * | PW_LOG_TOPIC_DEFAULT

## Detailed Description

Logging functions of PipeWire.

Logging is performed to stdout and stderr. Trace logging is performed in a lockfree ringbuffer and written out from the main thread as to not block the realtime threads.

## Macro Definition Documentation

## ◆ PW_LOG_TOPIC_STATIC

#define PW_LOG_TOPIC_STATIC | ( |  | var,
|  |  | topic
| ) |  |

Declare a static log topic named var.

The usual usage is:

PW_LOG_TOPIC_STATIC(my_topic);
#define PW_LOG_TOPIC_DEFAULT my_topic
void foo() {
pw_log_debug("bar");
}
PW_LOG_TOPIC_STATIC
#define PW_LOG_TOPIC_STATIC(var, topic)
Declare a static log topic named var.
Definition: src/pipewire/log.h:102
pw_log_debug
#define pw_log_debug(...)
Definition: src/pipewire/log.h:145

## ◆ PW_LOG_TOPIC_EXTERN

#define PW_LOG_TOPIC_EXTERN | ( |  | var | ) | extern struct spa_log_topic *var

Declare a static log topic named var.

See PW_LOG_TOPIC_STATIC for an example usage.

## ◆ PW_LOG_TOPIC

#define PW_LOG_TOPIC | ( |  | var,
|  |  | topic
| ) |  |

Declare a static log topic named var.

See PW_LOG_TOPIC_STATIC for an example usage.

## ◆ PW_LOG_TOPIC_INIT

#define PW_LOG_TOPIC_INIT | ( |  | var | ) | spa_log_topic_init(pw_log_get(), var);

## ◆ pw_log_level_enabled

#define pw_log_level_enabled | ( |  | lev | ) | (pw_log_level >= (lev))

Check if a loglevel is enabled.

## ◆ pw_log_topic_enabled

#define pw_log_topic_enabled | ( |  | lev,
|  |  | t
| ) |  | ((t) && (t)->has_custom_level ? (t)->level >= (lev) : pw_log_level_enabled((lev)))

## ◆ pw_logtv

#define pw_logtv | ( |  | lev,
|  |  | topic,
|  |  | fmt,
|  |  | ap
| ) |  |

## ◆ pw_logt

#define pw_logt | ( |  | lev,
|  |  | topic,
|  |  | ...
| ) |  |

## ◆ pw_log

#define pw_log | ( |  | lev,
|  |  | ...
| ) |  | pw_logt(lev,PW_LOG_TOPIC_DEFAULT,__VA_ARGS__)

## ◆ pw_log_error

#define pw_log_error | ( |  | ... | ) | pw_log(SPA_LOG_LEVEL_ERROR,__VA_ARGS__)

Examples
  bluez-session.c, export-sink.c, export-source.c, export-spa-device.c, export-spa.c, video-dsp-play.c, video-src-alloc.c, video-src-fixate.c, and video-src-reneg.c.

## ◆ pw_log_warn

#define pw_log_warn | ( |  | ... | ) | pw_log(SPA_LOG_LEVEL_WARN,__VA_ARGS__)

Examples
  audio-capture.c, audio-src.c, bluez-session.c, tutorial4.c, tutorial5.c, video-dsp-play.c, video-play-fixate.c, video-play-pull.c, video-play-reneg.c, video-play.c, video-src-alloc.c, video-src-fixate.c, video-src-reneg.c, and video-src.c.

## ◆ pw_log_info

#define pw_log_info | ( |  | ... | ) | pw_log(SPA_LOG_LEVEL_INFO,__VA_ARGS__)

Examples
  video-play-fixate.c, video-play-reneg.c, video-src-alloc.c, video-src-fixate.c, and video-src-reneg.c.

## ◆ pw_log_debug

#define pw_log_debug | ( |  | ... | ) | pw_log(SPA_LOG_LEVEL_DEBUG,__VA_ARGS__)

Examples
  bluez-session.c, and export-source.c.

## ◆ pw_log_trace

#define pw_log_trace | ( |  | ... | ) | pw_log(SPA_LOG_LEVEL_TRACE,__VA_ARGS__)

Examples
  audio-dsp-filter.c, audio-dsp-src.c, export-source.c, video-dsp-play.c, video-play-pull.c, video-play.c, video-src-alloc.c, video-src-fixate.c, video-src-reneg.c, and video-src.c.

## ◆ pw_logt_error

#define pw_logt_error | ( |  | t,
|  |  | ...
| ) |  | pw_logt(SPA_LOG_LEVEL_ERROR,t,__VA_ARGS__)

## ◆ pw_logt_warn

#define pw_logt_warn | ( |  | t,
|  |  | ...
| ) |  | pw_logt(SPA_LOG_LEVEL_WARN,t,__VA_ARGS__)

## ◆ pw_logt_info

#define pw_logt_info | ( |  | t,
|  |  | ...
| ) |  | pw_logt(SPA_LOG_LEVEL_INFO,t,__VA_ARGS__)

## ◆ pw_logt_debug

#define pw_logt_debug | ( |  | t,
|  |  | ...
| ) |  | pw_logt(SPA_LOG_LEVEL_DEBUG,t,__VA_ARGS__)

## ◆ pw_logt_trace

#define pw_logt_trace | ( |  | t,
|  |  | ...
| ) |  | pw_logt(SPA_LOG_LEVEL_TRACE,t,__VA_ARGS__)

## ◆ pw_log_trace_fp

#define pw_log_trace_fp | ( |  | ... | ) | pw_log(SPA_LOG_LEVEL_TRACE,__VA_ARGS__)

## Function Documentation

## ◆ pw_log_set()

void pw_log_set | ( | struct spa_log * | log | ) |

Configure a logging module.

This is usually done automatically in pw_init() but you can install a custom logger before calling pw_init().

Configure a logging module.

Parameters

  log | the global log to set

## ◆ pw_log_get()

struct spa_log * pw_log_get | ( | void |  | ) |

Get the log interface.

Get the log interface.

Returns
  the global log

## ◆ pw_log_set_level()

void pw_log_set_level | ( | enum spa_log_level | level | ) |

Configure the logging level.

Configure the logging level.

Parameters

  level | the new log level

## ◆ pw_log_logt()

void pw_log_logt | ( | enum spa_log_level | level,
|  | const struct spa_log_topic * | topic,
|  | const char * | file,
|  | int | line,
|  | const char * | func,
|  | const char * | fmt,
|  |  | ...
| ) |  |

Log a message for a topic.

## ◆ pw_log_logtv()

void void pw_log_logtv | ( | enum spa_log_level | level,
|  | const struct spa_log_topic * | topic,
|  | const char * | file,
|  | int | line,
|  | const char * | func,
|  | const char * | fmt,
|  | va_list | args
| ) |  |

Log a message for a topic.

## ◆ pw_log_log()

void void void pw_log_log | ( | enum spa_log_level | level,
|  | const char * | file,
|  | int | line,
|  | const char * | func,
|  | const char * | fmt,
|  |  | ...
| ) |  |

Log a message for the default topic.

## ◆ pw_log_logv()

void void void void pw_log_logv | ( | enum spa_log_level | level,
|  | const char * | file,
|  | int | line,
|  | const char * | func,
|  | const char * | fmt,
|  | va_list | args
| ) |  |

Log a message for the default topic.

## ◆ _pw_log_topic_new()

void void void void void _pw_log_topic_new | ( | struct spa_log_topic * | topic | ) |

Initialize the log topic.

The returned topic is owned by the pipewire context and the topic must not be modified or freed. Do not use this function directly, use one of PW_LOG_TOPIC_* instead.

See also
  PW_LOG_TOPIC_STATIC
  PW_LOG_TOPIC_EXTERN
  PW_LOG_TOPIC

## Variable Documentation

## ◆ pw_log_level

enum spa_log_level pw_log_level
| extern

The global log level.

## ◆ PW_LOG_TOPIC_DEFAULT

struct spa_log_topic* PW_LOG_TOPIC_DEFAULT
| extern